%%%Spherical Sampling for 3 D sensors.
%%%Mcat: original sharpening transform
%%%sensor: the sensors to sharpen
%%%points: the number of sampled points in the sphere
%%%radians: the distance requested from the seed point


%%%Mcatt: the set of sharpening transforms found. 


function [Mcatt]= Spherical3D(Mcat,sensor,points,radians)


[P,matri, aux,S,V]=sensorpoint(Mcat,sensor,points);



aux1=zeros(1,size(matri,1));
aux2=zeros(1,size(matri,1));
aux3=zeros(1,size(matri,1));


for i=1:size(matri,1)
	aux1(i)=AngleD(P(:,1)',matri(i,:));
	aux2(i)=AngleD(P(:,2)',matri(i,:));
	aux3(i)=AngleD(P(:,3)',matri(i,:));
end

values1=find(aux1<radians)';
values2=find(aux2<radians)';
values3=find(aux3<radians)';
disp('You have red sensors:')
disp(size(values1));
disp('You have green sensors:')
disp(size(values2));
disp('You have blue sensors:')
disp(size(values3));


red=matri(values1,:);
blue=matri(values3,:);
green=matri(values2,:);


[x y z]=meshgrid(1:1:size(values1),1:1:size(values2),1:1:size(values3));
mat=[reshape(x,1,[])' reshape(y,1,[])' reshape(z,1,[])'];



Mcatt=zeros(3,3,size(mat,1));

for i=1:1:size(mat,1)
   
	P=[red(mat(i,1),:)' ,green(mat(i,2),:)' blue(mat(i,3),:)']; 
	P(:,1)=P(:,1).*aux(1);
	P(:,2)=P(:,2).*aux(2);
	P(:,3)=P(:,3).*aux(3);

	Mcatt(:,:,i)=(inv(S*(V'))*P)';

end
