% %%%function that computes: 
% 1st: the set of points to sample (matri)
% 2nd: the SVM decomposition for the basis change (S,V).
% 3rd: the point P in the sphere for the original sharpening



function [P,matri,aux,S,V]= sensorpoint(Mcat,sensor,points)





n=1:1:points;
hn=-1+((2.*(n-1))./(n(end)-1));
phin=acos(hn);
thetan=zeros(1,(n(end)-1));
thetan(1)=0;
for i=2:1:(n(end)-1)
    thetan(i)=thetan(i-1)+(3.6/(sqrt(n(end))*sqrt(1-(hn(i).^2))));
end
thetan(n(end))=0;
x=1.*cos(thetan).*sin(phin);
y=1.*sin(thetan).*sin(phin);
z=1.*cos(phin);
matri=[x' y' z'];



[U,S,V] = svd(sensor,0);
P=S*(V')*Mcat';

aux=sqrt(sum(P.^2,1));
P(:,1)=P(:,1)./aux(1);
P(:,2)=P(:,2)./aux(2);
P(:,3)=P(:,3)./aux(3);

